Index: src/main/java/com/tourMate/dao/impl/TransportDaoImpl.java
===================================================================
--- src/main/java/com/tourMate/dao/impl/TransportDaoImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/dao/impl/TransportDaoImpl.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -2,6 +2,4 @@
 
 import com.tourMate.dao.TransportDao;
-import com.tourMate.dto.RouteListingDto;
-import com.tourMate.dto.TransportDto;
 import com.tourMate.entities.*;
 import jakarta.persistence.EntityManager;
@@ -37,83 +35,22 @@
 
     @Override
-    public List<TransportDto> getTransportsByUser(User u) {
-        List<Transport> transports = em.createQuery("select t from Transport t where t.owner = :u").setParameter("u", u).getResultList();
-        return transports.stream().map(x -> new TransportDto(
-                x.getTransportID(),
-                x.getTransportName(),
-                x.getCarBrand(),
-                x.getCarType(),
-                x.getCarManufacturedYear(),
-                x.getNoPassengers(),
-                x.getNoBags(),
-                x.getEMBG(),
-                x.getOwner(),
-                x.getCarPlate(),
-                x.getAvailableRoutes().stream().map(y -> new RouteListingDto(
-                        y.getTransportAvailibleId(),
-                        y.getFrom(),
-                        y.getTo(),
-                        y.getDate(),
-                        y.getFreeSpace(),
-                        y.getTime(),
-                        y.getRoutes(),
-                        y.getRoutes().stream()
-                                .mapToDouble(TransportRoute::getPrice)
-                                .max().orElse(0)
-                )).toList(),
-                x.getAvailableRoutes().stream()
-                        .flatMapToDouble(y -> y.getRoutes()
-                                .stream()
-                                .mapToDouble(TransportRoute::getPrice)).max().orElseGet(() -> 0)
-        )).toList();
+    public List<Transport> getTransportsByUser(User u) {
+        List<Transport> transports = em.createQuery("select t from Transport t where t.owner = :u or t.owner in :users")
+                .setParameter("u", u)
+                .setParameter("users", u.getConnectedAccounts())
+                .getResultList();
+        return transports;
     }
 
     @Override
-    public List<RouteListingDto> getRoutesForTransport(Transport t) {
+    public List<TransportAvailible> getRoutesForTransport(Transport t) {
         List<TransportAvailible> transportsAvailible = em.createQuery("select ta from TransportAvailible ta where ta.transport = :transport").setParameter("transport", t).getResultList();
-        return transportsAvailible.stream().map(x -> new RouteListingDto(
-                x.getTransportAvailibleId(),
-                x.getFrom(),
-                x.getTo(),
-                x.getDate(),
-                x.getFreeSpace(),
-                x.getTime(),
-                x.getRoutes(),
-                x.getRoutes().stream()
-                        .mapToDouble(TransportRoute::getPrice)
-                        .max().orElse(0)
-        )).toList();
+        return transportsAvailible;
     }
 
     @Override
-    public TransportDto findTransportById(long transportId) {
+    public Transport findTransportById(long transportId) {
         Transport x = em.find(Transport.class,transportId);
-        return new TransportDto(
-                x.getTransportID(),
-                x.getTransportName(),
-                x.getCarBrand(),
-                x.getCarType(),
-                x.getCarManufacturedYear(),
-                x.getNoPassengers(),
-                x.getNoBags(),
-                x.getEMBG(),
-                x.getOwner(),
-                x.getCarPlate(),
-                x.getAvailableRoutes().stream().map(y -> new RouteListingDto(
-                        y.getTransportAvailibleId(),
-                        y.getFrom(),
-                        y.getTo(),
-                        y.getDate(),
-                        y.getFreeSpace(),
-                        y.getTime(),
-                        y.getRoutes(),
-                        y.getRoutes().stream()
-                                .mapToDouble(TransportRoute::getPrice)
-                                .max().orElse(0)
-                )).toList(),
-                x.getAvailableRoutes().stream()
-                        .flatMapToDouble(y -> y.getRoutes()
-                                                        .stream()
-                                                        .mapToDouble(TransportRoute::getPrice)).max().orElseGet(() -> 0));
+        return x;
     }
 
Index: src/main/java/com/tourMate/dao/impl/UsersDaoImpl.java
===================================================================
--- src/main/java/com/tourMate/dao/impl/UsersDaoImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/dao/impl/UsersDaoImpl.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -4,24 +4,27 @@
 import com.tourMate.entities.Role;
 import com.tourMate.entities.User;
+import com.tourMate.events.OnProfileEnabledEvent;
+import com.tourMate.events.OnRegistrationSuccessEvent;
 import jakarta.persistence.EntityManager;
 import jakarta.persistence.PersistenceContext;
 import jakarta.transaction.Transactional;
-import org.jetbrains.annotations.NotNull;
 import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.context.ApplicationEventPublisher;
 import org.springframework.security.core.userdetails.UserDetails;
 import org.springframework.security.crypto.password.PasswordEncoder;
-import org.springframework.stereotype.Service;
+import org.springframework.stereotype.Repository;
 
 import java.util.Date;
 import java.util.List;
 
-@Service
+@Repository
 public class UsersDaoImpl implements UsersDao {
 
     @PersistenceContext
     EntityManager em;
-
     @Autowired
     PasswordEncoder passwordEncoder;
+    @Autowired
+    private ApplicationEventPublisher eventPublisher;
 
     @Transactional
@@ -30,5 +33,11 @@
         Role r = em.find(Role.class, 2);
         User user = new User(name, surname, email, passwordEncoder.encode("password"), birthDate, address, contact, r);
+        user.setProvider("local");
+        user.setLocked(true);
         em.persist(user);
+        if(user.getProvider().equals("local"))
+        {
+            eventPublisher.publishEvent(new OnRegistrationSuccessEvent(user));
+        }
     }
 
@@ -84,4 +93,5 @@
         u.setEnabled(true);
         em.persist(u);
+        eventPublisher.publishEvent(new OnProfileEnabledEvent(u));
     }
 
@@ -93,8 +103,42 @@
     @Override
     @Transactional
-    public void updateUser(User s) {
+    public User updateUser(User s) {
         em.persist(s);
+        return s;
     }
 
+    @Override
+    public User findByUsernameAndProvider(String username, String providers)
+    {
+        try
+        {
+            return (User) em.createQuery("select u from User u where u.email = :username and u.provider = :provider")
+                    .setParameter("username", username)
+                    .setParameter("provider", providers)
+                    .getSingleResult();
+        }
+        catch (Exception ex)
+        {
+            return null;
+        }
+    }
 
+    @Override
+    @Transactional
+    public User mergeUser(User user) {
+        return em.merge(user);
+    }
+
+    @Override
+    public List<User> getAdmins() {
+        return em.createQuery("select u from User u where u.role.roleName = 'SUPERADMIN'")
+                .getResultList();
+    }
+
+    @Override
+    public List<User> findConnectedAccountsByUser(User u) {
+        return em.createQuery("select u.connectedAccounts from User u where u = :user")
+                .setParameter("user", u)
+                .getResultList();
+    }
 }
Index: src/main/java/com/tourMate/dto/HotelDto.java
===================================================================
--- src/main/java/com/tourMate/dto/HotelDto.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/dto/HotelDto.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -21,6 +21,7 @@
     private double averageScore;
     private List<HotelsImages> images;
-
-    public HotelDto(long hotelId, String hotelName, String hotelDescripiton, String hotelLocation, String hotelEDBS, Boolean parking, Boolean petFriendly, Boolean internetAvailable, double totalPrice, List<HotelRoomAvailable> hotelRooms, List<Reviews> hotelReviews, double averageScore, List<HotelsImages> images) {
+    private Boolean promoted;
+    private Boolean marketed;
+    public HotelDto(long hotelId, String hotelName, String hotelDescripiton, String hotelLocation, String hotelEDBS, Boolean parking, Boolean petFriendly, Boolean internetAvailable, double totalPrice, List<HotelRoomAvailable> hotelRooms, List<Reviews> hotelReviews, double averageScore, List<HotelsImages> images, Boolean promoted, Boolean marketed) {
         this.hotelId = hotelId;
         this.hotelName = hotelName;
@@ -36,4 +37,6 @@
         this.averageScore = averageScore;
         this.images = images;
+        this.promoted = promoted;
+        this.marketed = marketed;
     }
 
@@ -132,3 +135,27 @@
         this.images = images;
     }
+
+    public void setHotelReviews(List<Reviews> hotelReviews) {
+        this.hotelReviews = hotelReviews;
+    }
+
+    public void setAverageScore(double averageScore) {
+        this.averageScore = averageScore;
+    }
+
+    public Boolean getPromoted() {
+        return promoted;
+    }
+
+    public void setPromoted(Boolean promoted) {
+        this.promoted = promoted;
+    }
+
+    public Boolean getMarketed() {
+        return marketed;
+    }
+
+    public void setMarketed(Boolean marketed) {
+        this.marketed = marketed;
+    }
 }
Index: src/main/java/com/tourMate/dto/PrincipalInfo.java
===================================================================
--- src/main/java/com/tourMate/dto/PrincipalInfo.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/dto/PrincipalInfo.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,71 @@
+package com.tourMate.dto;
+
+public class PrincipalInfo {
+    Long id;
+    String username;
+    String role;
+    String name;
+    String surname;
+    String email;
+
+    public PrincipalInfo(Long id, String username, String role, String name, String surname, String email) {
+        this.id = id;
+        this.username = username;
+        this.role = role;
+        this.name = name;
+        this.surname = surname;
+        this.email = email;
+    }
+
+    public PrincipalInfo() {
+
+    }
+
+    public Long getId() {
+        return id;
+    }
+
+    public void setId(Long id) {
+        this.id = id;
+    }
+
+    public String getUsername() {
+        return username;
+    }
+
+    public void setUsername(String username) {
+        this.username = username;
+    }
+
+    public String getRole() {
+        return role;
+    }
+
+    public void setRole(String role) {
+        this.role = role;
+    }
+
+    public String getName() {
+        return name;
+    }
+
+    public void setName(String name) {
+        this.name = name;
+    }
+
+    public String getSurname() {
+        return surname;
+    }
+
+    public void setSurname(String surname) {
+        this.surname = surname;
+    }
+
+    public String getEmail() {
+        return email;
+    }
+
+    public void setEmail(String email) {
+        this.email = email;
+    }
+}
Index: src/main/java/com/tourMate/entities/Providers.java
===================================================================
--- src/main/java/com/tourMate/entities/Providers.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/entities/Providers.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,8 @@
+package com.tourMate.entities;
+
+public enum Providers {
+    local,
+    github,
+    google,
+    facebook
+}
Index: src/main/java/com/tourMate/entities/User.java
===================================================================
--- src/main/java/com/tourMate/entities/User.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/entities/User.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -14,4 +14,5 @@
 import java.util.Collections;
 import java.util.Date;
+import java.util.List;
 
 @Entity
@@ -27,5 +28,5 @@
     private String name;
 
-    @Column(name = "surname", unique = false, nullable = false)
+    @Column(name = "surname", unique = false, nullable = true)
     private String surname;
 
@@ -34,16 +35,16 @@
     private String email;
 
-    @Column(name = "password", unique = true, nullable = false)
+    @Column(name = "password", unique = true, nullable = true)
     @NotNull
     private String password;
 
-    @Column(name = "birth_date", unique = false, nullable = false)
+    @Column(name = "birth_date", unique = false, nullable = true)
     @NotNull
     private Date birthDate;
 
-    @Column(name = "address", unique = false, nullable = false)
+    @Column(name = "address", unique = false, nullable = true)
     private String address;
 
-    @Column(name = "contact", unique = false, nullable = false)
+    @Column(name = "contact", unique = false, nullable = true)
     private String contact;
 
@@ -57,4 +58,11 @@
     boolean enabled;
 
+    @Column(name = "provider", unique = false, nullable = true)
+    String provider;
+
+    @ManyToMany
+    @JsonIgnore
+    List<User> connectedAccounts;
+
 
     public User(@NotNull String name, String surname, @NotNull String email, @NotNull String password, @NotNull Date birthDate, String address, String contact, Role role) {
@@ -120,4 +128,16 @@
     }
 
+    public List<User> getConnectedAccounts() {
+        return connectedAccounts;
+    }
+
+    public void setConnectedAccounts(List<User> connectedAccounts) {
+        this.connectedAccounts = connectedAccounts;
+    }
+
+    public void addConnectedUser(User u)
+    {
+        connectedAccounts.add(u);
+    }
 
     public void setSurname(String surname) {
@@ -212,3 +232,11 @@
         this.enabled = enabled;
     }
+
+    public String getProvider() {
+        return provider;
+    }
+
+    public void setProvider(String  provider) {
+        this.provider = provider;
+    }
 }
Index: src/main/java/com/tourMate/events/EmailEvent.java
===================================================================
--- src/main/java/com/tourMate/events/EmailEvent.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/events/EmailEvent.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,48 @@
+package com.tourMate.events;
+
+import com.tourMate.entities.User;
+import org.springframework.context.ApplicationEvent;
+
+public abstract class EmailEvent extends ApplicationEvent {
+    protected EventType eventType;
+    protected User user;
+    protected String subject;
+    protected String message;
+
+    public EmailEvent(User user) {
+        super(user);
+        this.user = user;
+    }
+
+    public User getUser() {
+        return user;
+    }
+
+    public void setUser(User user) {
+        this.user = user;
+    }
+
+    public EventType getEventType() {
+        return eventType;
+    }
+
+    public void setEventType(EventType eventType) {
+        this.eventType = eventType;
+    }
+
+    public String getSubject() {
+        return subject;
+    }
+
+    public void setSubject(String subject) {
+        this.subject = subject;
+    }
+
+    public String getMessage() {
+        return message;
+    }
+
+    public void setMessage(String message) {
+        this.message = message;
+    }
+}
Index: src/main/java/com/tourMate/events/EventType.java
===================================================================
--- src/main/java/com/tourMate/events/EventType.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/events/EventType.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,10 @@
+package com.tourMate.events;
+
+public enum EventType {
+    REGISTRATION,
+    PROFILE_ENABLED,
+    BUSINESS_APPROVED,
+    HOTEL_RESERVATION,
+    TRANSPORT_RESERVATION,
+    RESTAURANT_RESERVATION
+}
Index: src/main/java/com/tourMate/events/OnBusinessApprovedEvent.java
===================================================================
--- src/main/java/com/tourMate/events/OnBusinessApprovedEvent.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/events/OnBusinessApprovedEvent.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,12 @@
+package com.tourMate.events;
+
+import com.tourMate.entities.User;
+
+public class OnBusinessApprovedEvent extends EmailEvent{
+    public OnBusinessApprovedEvent(User u) {
+        super(u);
+        this.eventType = EventType.BUSINESS_APPROVED;
+        this.subject = "TourMate - Верификуван бизнис";
+        this.message = "Драг кориснику,\n\nВе известуваме дека Вашата регистрација за фирма е одобрена. Можете да започнете со користење на бизнис услугите од нашата апликација.\n\n\nСо почит,\nTourMate";
+    }
+}
Index: src/main/java/com/tourMate/events/OnHotelReservationEvent.java
===================================================================
--- src/main/java/com/tourMate/events/OnHotelReservationEvent.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/events/OnHotelReservationEvent.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,32 @@
+package com.tourMate.events;
+
+import com.tourMate.entities.HotelRoomReservations;
+import com.tourMate.entities.User;
+
+import java.text.SimpleDateFormat;
+
+public class OnHotelReservationEvent extends EmailEvent{
+    private HotelRoomReservations hotelRoomReservations;
+    public OnHotelReservationEvent(User u, HotelRoomReservations hotelRoomReservations) {
+        super(u);
+        this.hotelRoomReservations = hotelRoomReservations;
+        this.eventType = EventType.HOTEL_RESERVATION;
+        this.subject = "TourMate - Потврда за резервација - " + hotelRoomReservations.getHotelRoom().getHotel().getHotelName();
+        this.message = String.format("Драг кориснику,\n\nВе известуваме дека Вашата резервација за %s е потврдена\n\n" +
+                        "Детали за резервацијата:\n" +
+                        "%s - %s" +
+                        "\n%s" +
+                        "\n\n\nСо почит,\nTourMate", hotelRoomReservations.getHotelRoom().getHotel().getHotelName()
+                , new SimpleDateFormat("dd-MM-yyyy").format(hotelRoomReservations.getDateFrom())
+                , new SimpleDateFormat("dd-MM-yyyy").format(hotelRoomReservations.getDateTo())
+                , hotelRoomReservations.getHotelRoom().getHotelRoomName());
+    }
+
+    public HotelRoomReservations getHotelRoomReservations() {
+        return hotelRoomReservations;
+    }
+
+    public void setHotelRoomReservations(HotelRoomReservations hotelRoomReservations) {
+        this.hotelRoomReservations = hotelRoomReservations;
+    }
+}
Index: src/main/java/com/tourMate/events/OnProfileEnabledEvent.java
===================================================================
--- src/main/java/com/tourMate/events/OnProfileEnabledEvent.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/events/OnProfileEnabledEvent.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,17 @@
+package com.tourMate.events;
+
+import com.tourMate.entities.User;
+import jdk.jfr.Event;
+import org.springframework.context.ApplicationEvent;
+
+public class OnProfileEnabledEvent extends EmailEvent {
+    private static final long serialVersionUID = 1L;
+    private User user;
+
+    public OnProfileEnabledEvent(User user) {
+        super(user);
+        this.eventType = EventType.PROFILE_ENABLED;
+        this.subject = "TourMate - Активиран профил";
+        this.message = "Драг кориснику,\n\nВе известуваме дека Вашата регистрација е ревидирана од страна на администраторот и Вашиот профил е одобрен. Можете да започнете со користење.\n\n\nСо почит,\nTourMate";
+    }
+}
Index: src/main/java/com/tourMate/events/OnRegistrationSuccessEvent.java
===================================================================
--- src/main/java/com/tourMate/events/OnRegistrationSuccessEvent.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/events/OnRegistrationSuccessEvent.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,17 @@
+package com.tourMate.events;
+
+import com.tourMate.entities.User;
+import lombok.Data;
+import org.springframework.context.ApplicationEvent;
+
+public class OnRegistrationSuccessEvent extends EmailEvent {
+    private static final long serialVersionUID = 1L;
+    private User user;
+
+    public OnRegistrationSuccessEvent(User user) {
+        super(user);
+        this.eventType = EventType.REGISTRATION;
+        this.subject = "TourMate - Успешна регистрација";
+        this.message = "Драг кориснику,\n\nВе известуваме дека Вашата регистрација на апликацијата TourMate е успешна. За да можете да го користите профилот, потребно е истиот да е одобрен од страна на администраторот за што ќе добиете дополнителна потврда на оваа адреса.\n\n\nСо почит,\nTourMate";
+    }
+}
Index: src/main/java/com/tourMate/events/OnRestaurantReservationEvent.java
===================================================================
--- src/main/java/com/tourMate/events/OnRestaurantReservationEvent.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/events/OnRestaurantReservationEvent.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,34 @@
+package com.tourMate.events;
+
+import com.tourMate.entities.RestaurantReservations;
+import com.tourMate.entities.TransportReservation;
+import com.tourMate.entities.User;
+
+import java.text.SimpleDateFormat;
+
+public class OnRestaurantReservationEvent extends EmailEvent {
+    private RestaurantReservations restaurantReservations;
+    public OnRestaurantReservationEvent(User u, RestaurantReservations restaurantReservations) {
+        super(u);
+        this.restaurantReservations = restaurantReservations;
+        this.eventType = EventType.RESTAURANT_RESERVATION;
+        this.subject = "TourMate - Потврда за резервација - " + restaurantReservations.getTable().getRestaurant().getRestaurantName();
+        this.message = String.format("Драг кориснику,\n\nВе известуваме дека Вашата резервација за %s е потврдена\n\n" +
+                        "Детали за резервацијата:\n" +
+                        "%s - %s" +
+                        "\nМаса за %s луѓе" +
+                        "\n\n\nСо почит,\nTourMate", restaurantReservations.getTable().getRestaurant().getRestaurantName()
+                , new SimpleDateFormat("dd-MM-yyyy hh:mm").format(restaurantReservations.getTimeFrom())
+                , new SimpleDateFormat("dd-MM-yyyy hh:mm").format(restaurantReservations.getTimeTo())
+                , restaurantReservations.getTable().getNoSeats());
+
+    }
+
+    public RestaurantReservations getRestaurantReservations() {
+        return restaurantReservations;
+    }
+
+    public void setRestaurantReservations(RestaurantReservations restaurantReservations) {
+        this.restaurantReservations = restaurantReservations;
+    }
+}
Index: src/main/java/com/tourMate/events/OnTransportReservationEvent.java
===================================================================
--- src/main/java/com/tourMate/events/OnTransportReservationEvent.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/events/OnTransportReservationEvent.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,30 @@
+package com.tourMate.events;
+
+import com.tourMate.entities.HotelRoomReservations;
+import com.tourMate.entities.TransportReservation;
+import com.tourMate.entities.User;
+
+public class OnTransportReservationEvent extends EmailEvent {
+    private TransportReservation transportReservation;
+    public OnTransportReservationEvent(User u, TransportReservation transportReservation) {
+        super(u);
+        this.transportReservation = transportReservation;
+        this.eventType = EventType.HOTEL_RESERVATION;
+
+        this.subject = "TourMate - Потврда за резервација за рута " + transportReservation.getTransportRoute().getFrom() + " " + transportReservation.getTransportRoute().getTo();
+        this.message = String.format("Драг кориснику,\n\nВе известуваме дека Вашата резервација за патувањето %s е потврдена\n\n" +
+                        "Детали за резервацијата:\n" +
+                        "%s - %s" +
+                        "\n\n\nСо почит,\nTourMate", transportReservation.getTransportRoute().getFrom() + " " + transportReservation.getTransportRoute().getTo()
+                , transportReservation.getTransportRoute().getDeparture()
+                , transportReservation.getTransportRoute().getArrival());
+    }
+
+    public TransportReservation getTransportReservation() {
+        return transportReservation;
+    }
+
+    public void setTransportReservation(TransportReservation transportReservation) {
+        this.transportReservation = transportReservation;
+    }
+}
Index: src/main/java/com/tourMate/listeners/RegistrationEmailListener.java
===================================================================
--- src/main/java/com/tourMate/listeners/RegistrationEmailListener.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/listeners/RegistrationEmailListener.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,27 @@
+package com.tourMate.listeners;
+
+import com.tourMate.entities.User;
+import com.tourMate.events.*;
+import com.tourMate.services.MailingService;
+import com.tourMate.services.UsersManager;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.context.ApplicationListener;
+import org.springframework.core.env.Environment;
+import org.springframework.stereotype.Component;
+
+import java.text.SimpleDateFormat;
+
+@Component
+public class RegistrationEmailListener implements ApplicationListener<EmailEvent> {
+
+    @Autowired
+    private Environment environment;
+    @Autowired
+    private MailingService mailingService;
+
+
+    @Override
+    public void onApplicationEvent(EmailEvent event) {
+        mailingService.sendMail(event.getUser().getEmail(), event.getSubject(), event.getMessage());
+    }
+}
Index: src/main/java/com/tourMate/services/HotelManager.java
===================================================================
--- src/main/java/com/tourMate/services/HotelManager.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/services/HotelManager.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -25,8 +25,8 @@
     public HotelRoom findRoomById (long hotelRoomId);
     public List<HotelRoomImages> getRoomImages(Long hotelRoom);
-    public void createRoom(Hotels hotel, String hotelRoomDescription, String hotelRoomName, Boolean kitchenAvailable, Boolean airConditioning, Boolean balcony, double price, int numOfBeds);
+    public void createRoom(Long hotelId, String hotelRoomDescription, String hotelRoomName, Boolean kitchenAvailable, Boolean airConditioning, Boolean balcony, double price, int numOfBeds);
     public void editRoom(long hotelRoomId, Hotels hotel, String hotelRoomDescription, String hotelRoomName, Boolean kitchenAvailable, Boolean airConditioning, Boolean balcony, double price);
     public void deleteRoom(long hotelRoomId);
-    public void createRoomAvailible(HotelRoom hotelRoom, Date dateFrom, Date dateTo, int numberOfBeds);
+    public void createRoomAvailible(long hotelRoom, Date dateFrom, Date dateTo, int numberOfBeds);
     public void editRoomAvailible(long hotelRoomAvailableId, HotelRoom hotelRoom, Date dateFrom, Date dateTo, int numberOfBeds);
     public void editRoomAvailibleReservation(Long HotelRoomAvailableId, Long hotelRoomId, Date from, Date to, int numberOfBeds);
@@ -36,4 +36,7 @@
     public List<HotelRoomAvailable> getRoomsAvailableById(Long id);
     public List<HotelRoomAvailable> getRoomsAvailibilityByHotel(Hotels hotel);
+
+    List<HotelRoomReservations> getReservationsInPeriod(String hotelLocation, Date dateFrom, Date dateTo);
+
     public List<HotelDto> getRoomsAvailibilityByDateAndLocation(String hotelLocation, Date dateFrom, Date dateTo, int numberOfBeds, Boolean flexible);
     public void createReservation(Long userId, Long hotelRoomId, Long hotelRoomAvailableId, Date dateFrom, Date dateTo, Integer numberOfBeds);
Index: src/main/java/com/tourMate/services/MailingService.java
===================================================================
--- src/main/java/com/tourMate/services/MailingService.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/services/MailingService.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,5 @@
+package com.tourMate.services;
+
+public interface MailingService {
+    public void sendMail(String to, String subject, String message);
+}
Index: src/main/java/com/tourMate/services/RestaurantManager.java
===================================================================
--- src/main/java/com/tourMate/services/RestaurantManager.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/services/RestaurantManager.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -37,5 +37,5 @@
     public List<RestaurantsTable> getRestaurantTables(long restaurantID);
 
-    public List<RestaurantDto> getTablesByDateAndLocation(String restaurantLocation, Date hourFrom, Date hourTo, int noSeats);
+    public List<RestaurantDto> getTablesByDateAndLocation(String restaurantLocation, Date date, String hourFrom, String hourTo, int noSeats);
 
     public RestaurantsTable findTableById(long tableId);
Index: src/main/java/com/tourMate/services/TransportManager.java
===================================================================
--- src/main/java/com/tourMate/services/TransportManager.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/services/TransportManager.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -45,5 +45,5 @@
     public List<TransportAvailible> getTransportsAvailable();
 
-    public void createTransportAvailable(Transport transport, String departureLocation, String arrivalLocation, Date date, Integer noSeats, Date departureHour, Collection<TransportRoute> routes);
+    public void createTransportAvailable(TransportAvailible transportAvailible, Transport transport, String departureLocation, String arrivalLocation, Date date, Integer noSeats, Date departureHour, Long trnasportId, Collection<TransportRoute> routes);
     public void editTransportAvailable(Transport transport, long availableID, String departureLocation, String arrivalLocation, Date date, Integer noSeats, Date departureHour);
 
